Package org.zkoss.stateless.sul

## Interface IComboitem

- All Superinterfaces:
    `IChildrenOfInputgroup<IComboitem>`, `IComponent<IComboitem>`, `IDisable<IComboitem>`, `IHtmlBasedComponent<IComboitem>`, `ILabelElement<IComboitem>`, `ILabelImageElement<IComboitem>`, `IXulElement<IComboitem>`

      public interface IComboitem
      extends ILabelImageElement<IComboitem>, IDisable<IComboitem>

  Immutable `Comboitem` component

  An item of a combo box.

  Author:
    katherine
  See Also:
    `Comboitem`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `IComboitem.Builder` | Builds instances of type `IComboitem`.
    `static class` | `IComboitem.Updater` | Builds an updater of type `IComboitem` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static IComboitem` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default java.lang.String` | `getContent()` | Returns the embedded content (i.e., HTML tags) that is shown as part of the description.
    `default java.lang.String` | `getDescription()` | Returns the description (never null).
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `static IComboitem` | `of​(java.lang.String label)` | Returns the instance with the given label
    `static IComboitem` | `of​(java.lang.String label, java.lang.String image)` | Returns the instance with the given label and image
    `static IComboitem` | `ofId​(java.lang.String id)` | Returns the instance with the given id.
    `static IComboitem` | `ofImage​(java.lang.String image)` | Returns the instance with the given image
    `IComboitem` | `withContent​(java.lang.String content)` | Returns a copy of `this` immutable component with the specified `content`.
    `IComboitem` | `withDescription​(java.lang.String description)` | Returns a copy of `this` immutable component with the specified `description`.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IDisable

      `isDisabled, withDisabled`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getWidth, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withHflex, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withWidth, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.ILabelElement

      `getLabel, withLabel`

    - ### Methods inherited from interface org.zkoss.stateless.sul.ILabelImageElement

      `getHoverImage, getIconSclass, getIconSclasses, getIconTooltip, getIconTooltips, getImage, isPreloadImage, withHoverImage, withIconSclass, withIconSclasses, withIconTooltip, withIconTooltips, withImage, withPreloadImage`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final IComboitem DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zul.inp.Comboitem"`

      Specified by:
        `getWidgetClass` in interface `IComponent<IComboitem>`

    - #### getDescription

          default java.lang.String getDescription()

      Returns the description (never null). The description is used to provide extra information such that users is easy to make a selection.

      Default: `""`.

    - #### withDescription

          IComboitem withDescription​(java.lang.String description)

      Returns a copy of `this` immutable component with the specified `description`.

      Sets the description.

      Parameters:
        `description` - The description of the comboitem.

        Default: `""`.

      Returns:
        A modified copy of the `this` object

    - #### getContent

          default java.lang.String getContent()

      Returns the embedded content (i.e., HTML tags) that is shown as part of the description.

      It is useful to show the description in more versatile way.

      Default: `""`

      See Also:
        `getDescription()`

    - #### withContent

          IComboitem withContent​(java.lang.String content)

      Returns a copy of `this` immutable component with the specified `content`.

      Sets the embedded content (i.e., HTML tags) that is shown as part of the description.

      It is useful to show the description in more versatile way.

      Default: `""`.

      #### Security Note

      Unlike other methods, the content assigned to this method is generated directly to the browser without escaping. Thus, it is better not to have something input by the user to avoid any XSS attach.

      Note: the content is sanitized by default to avoid XSS attack, and please don't use JavaScript in the content.

      Parameters:
        `content` - The embedded content of the comboitem to display

        Default: `""`.

      Returns:
        A modified copy of the `this` object

    - #### of

          static IComboitem of​(java.lang.String label)

      Returns the instance with the given label
      Parameters:
        `label` - The label of the comboitem

    - #### of

          static IComboitem of​(java.lang.String label,
                               java.lang.String image)

      Returns the instance with the given label and image
      Parameters:
        `label` - The label of the comboitem
        `image` - The image of the comboitem

    - #### ofImage

          static IComboitem ofImage​(java.lang.String image)

      Returns the instance with the given image
      Parameters:
        `image` - The image of the comboitem

    - #### ofId

          static IComboitem ofId​(java.lang.String id)

      Returns the instance with the given id.
      Parameters:
        `id` - The id to identify this component